package ru.dbotthepony.kstarbound.world.entities.tile

import ru.dbotthepony.kommons.util.getValue
import ru.dbotthepony.kommons.util.setValue
import ru.dbotthepony.kstarbound.Registry
import ru.dbotthepony.kstarbound.defs.`object`.ObjectDefinition
import ru.dbotthepony.kstarbound.math.Interpolator
import ru.dbotthepony.kstarbound.network.syncher.networkedBoolean
import ru.dbotthepony.kstarbound.network.syncher.networkedBytes
import ru.dbotthepony.kstarbound.network.syncher.networkedFloat
import ru.dbotthepony.kstarbound.network.syncher.networkedSignedInt

class ContainerObject(config: Registry.Entry<ObjectDefinition>) : WorldObject(config) {
	var opened by networkedSignedInt().also { networkGroup.upstream.add(it) }
	var isCrafting by networkedBoolean().also { networkGroup.upstream.add(it) }
	var craftingProgress by networkedFloat().also { networkGroup.upstream.add(it); it.interpolator = Interpolator.Linear }
	// i have no words.
	// this field embeds ENTIRE net state of 'ItemBag',
	// and each time container is updated, its contents are networked fully
	// each. damn. time.
	// placeholder data, container size 40, read 0 items
	var itemsNetState by networkedBytes(byteArrayOf(40, 0)).also { networkGroup.upstream.add(it) }
}
